#!/bin/bash



BUNDLERESOURCEPATH="$(dirname "$0")/../Resources"
EXEARGS=



#find wine, try in Bundle, ~/Applications, /Applications, Spotlight
if [ -f "$BUNDLERESOURCEPATH/Wine.bundle/Contents/Resources/bin/wine" ]; then
    export WINEUSRPATH="$BUNDLERESOURCEPATH/Wine.bundle/Contents/Resources"
elif [ -f "$HOME/Applications/Wine.app/Contents/Resources/bin/wine" ]; then
    export WINEUSRPATH="$HOME/Applications/Wine.app/Contents/Resources"
elif [ -f "/Applications/Wine.app/Contents/Resources/bin/wine" ]; then
    export WINEUSRPATH="/Applications/Wine.app/Contents/Resources"
elif [ -f "$(mdfind 'kMDItemCFBundleIdentifier == org.kronenberg.Wine' | grep -m 1 'Wine.app')/Contents/Resources/bin/wine" ]; then
    export WINEUSRPATH="$(mdfind 'kMDItemCFBundleIdentifier == org.kronenberg.Wine' | grep -m 1 'Wine.app')/Contents/Resources"
else
    echo "Wine not found!"
    exit 1
fi



# create working copy
export WINEPREFIX="$HOME/Library/Application Support/$(defaults read "$BUNDLERESOURCEPATH/../Info" CFBundleIdentifier)"
if [ ! -d "$WINEPREFIX" ]; then
    "$BUNDLERESOURCEPATH/Winetricks.app/Contents/MacOS/./Winetricks" "$BUNDLERESOURCEPATH/wineprefix.zip" "$WINEPREFIX" "$(defaults read "$BUNDLERESOURCEPATH/../Info" CFBundleName)"
fi



# exports (fix new Freetype 2.7+ engine) (https://bugs.winehq.org/show_bug.cgi?id=41639)
export PATH="$WINEUSRPATH/bin":"$PATH"
export LD_LIBRARY_PATH="$LD_LIBRARY_PATH":"$WINEUSRPATH/lib"
export DYLD_FALLBACK_LIBRARY_PATH="/usr/lib":"$WINEUSRPATH/lib"
export WINEPATH="$WINEUSRPATH/bin"
export FREETYPE_PROPERTIES="truetype:interpreter-version=35"
export WINEARCH=win32



#some default windows vars that might be missing ( http://ss64.com/nt/syntax-variables.html )
[ -z "$COMPUTERNAME" ] && export COMPUTERNAME="$(/usr/sbin/scutil --get ComputerName)"



# start wine and program, if possible in the programs root directory, change to forwardslashes
BIN_FILE="$(sed 's|\\|/|g' <<< "$(defaults read "$BUNDLERESOURCEPATH/../Info" WineProgramPath)")"
BIN_PATH="$BUNDLERESOURCEPATH/wineprefix/drive_c$(sed 's|C:||' <<< "$(dirname "$BIN_FILE")")"
if [ -d "$BIN_PATH" ]; then
    cd "$BIN_PATH"
fi
if [ "$(defaults read "$BUNDLERESOURCEPATH/../Info" WineProgramArguments)" != "" ]; then
"$WINEUSRPATH/bin/wine" "$BIN_FILE" $(defaults read "$BUNDLERESOURCEPATH/../Info" WineProgramArguments) "$@" & PID=$!
else
"$WINEUSRPATH/bin/wine" "$BIN_FILE" "$@" & PID=$!
fi



# change name of App
for i in $(seq 1 10); do
    sleep 1
    lsappinfo setinfo $PID --name "$(defaults read "$BUNDLERESOURCEPATH/../Info" CFBundleName)"
done
